<?php
// Admin Options Page

add_action('admin_init', 'easygalleryslider_admin_init');
function easygalleryslider_admin_init(){
	register_setting( 'easygalleryslider_options', 'easygalleryslider', 'easygalleryslider_options_validate' );
	add_settings_section('easygalleryslider_options', 'Plugin Settings', 'easygalleryslider_section_text', 'easygalleryslider');
	add_settings_field('auto_insert', 'Automatically insert above', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_options', array('field' => 'auto_insert'));
	add_settings_field('shortcode', 'Enable shortcode/PHP function', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_options', array('field' => 'shortcode'));
	add_settings_section('easygalleryslider_appearance_options', 'Default Slider Animation and Structure', 'easygalleryslider_section_text', 'easygalleryslider');
	add_settings_field('width', 'Max Width', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'width'));
	add_settings_field('height', 'Max Height', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'height'));
	add_settings_field('num_slides', 'Number of slides', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'num_slides'));
	add_settings_field('fs_slideshow', 'Automatically Slide', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_slideshow'));
	add_settings_field('fs_speed', 'Slideshow Speed', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_speed'));
	add_settings_field('fs_duration', 'Animation Duration', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_duration'));
	add_settings_field('fs_animation', 'Animation Style', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_animation'));
	add_settings_field('fs_slide_direction', 'Slide Direction', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_slide_direction'));
	add_settings_field('spinner', 'Show loading spinner', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'spinner'));
	add_settings_field('title', 'Show titles', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'title'));
	add_settings_field('fs_random', 'Randomize slides', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'fs_random'));
	add_settings_field('order', 'Order slides by', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'order'));
	add_settings_field('exclude', 'Exclude images with menu order higher than 999', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'exclude'));
	add_settings_field('enlarge', 'Small images', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'enlarge'));
	add_settings_field('enlarge_xy', 'Small images determined by', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'enlarge_xy'));
	add_settings_field('matte', 'Small images background color', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_appearance_options', array('field' => 'matte'));
	add_settings_section('easygalleryslider_navigation_options', 'Default Slider Navigation', 'easygalleryslider_section_text', 'easygalleryslider');
	add_settings_field('fs_loop', 'Loop animation', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_loop'));
	add_settings_field('fs_actionpause', 'Pause when buttons clicked', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_actionpause'));
	add_settings_field('fs_hover', 'Pause slideshow when hovering', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_hover'));
	add_settings_field('fs_directionnav', 'Show prev/next buttons', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_directionnav'));
	add_settings_field('fs_controlnav', 'Show navigation "dots"', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_controlnav'));
	add_settings_field('fs_pause', 'Show pause/play button', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_pause'));
	add_settings_field('fs_keynav', 'Keyboard navigation', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_keynav'));
	add_settings_field('fs_mousewheel', 'Mouse scroll wheel navigation', 'easygalleryslider_field_text', 'easygalleryslider', 'easygalleryslider_navigation_options', array('field' => 'fs_mousewheel'));
}

function easygalleryslider_section_text() { echo ''; }

function easygalleryslider_field_text($args) {
	$egsoptions = get_option('easygalleryslider');
	switch($args['field']) {
		case "fs_animation":
			echo '<select name="easygalleryslider[fs][animation]"><option value="fade"'.(($egsoptions[fs][animation]=='fade')?' selected="selected"':"").'>fade</option><option value="slide"'.(($egsoptions[fs][animation]=='slide')?' selected="selected"':"").'>slide</option></select>'; break;
		case "fs_slide_direction":
			echo '<select name="easygalleryslider[fs][slideDirection]"><option value="horizontal"'.(($egsoptions[fs][slideDirection]=='horizontal')?' selected="selected"':"").'>horizontal</option><option value="vertical"'.(($egsoptions[fs][slideDirection]=='vertical')?' selected="selected"':"").'>vertical</option></select><div class="egs-opinfo">for "slide" animation style</div>'; break;
		case "fs_slideshow":
			echo '<input type="checkbox" name="easygalleryslider[fs][slideshow]" value="true"'.(($egsoptions[fs][slideshow]==true)?' checked="checked"':"").' />'; break;
		case "fs_speed":
			echo '<input type="text" name="easygalleryslider[fs][slideshowSpeed]" size="3" value="'.$egsoptions[fs][slideshowSpeed].'" /> ms'; break;
		case "fs_duration":
			echo '<input type="text" name="easygalleryslider[fs][animationDuration]" size="3" value="'.$egsoptions[fs][animationDuration].'" /> ms'; break;
		case "fs_directionnav":
			echo '<input type="checkbox" name="easygalleryslider[fs][directionNav]" value="true"'.(($egsoptions[fs][directionNav]==true)?' checked="checked"':"").' />'; break;
		case "fs_controlnav":
			echo '<input type="checkbox" name="easygalleryslider[fs][controlNav]" value="true"'.(($egsoptions[fs][controlNav]==true)?' checked="checked"':"").' />'; break;
		case "fs_keynav":
			echo '<input type="checkbox" name="easygalleryslider[fs][keyboardNav]" value="true"'.(($egsoptions[fs][keyboardNav]==true)?' checked="checked"':"").' />'; break;
		case "fs_mousewheel":
			echo '<input type="checkbox" name="easygalleryslider[fs][mousewheel]" value="true"'.(($egsoptions[fs][mousewheel]==true)?' checked="checked"':"").' />'; break;
		case "fs_pause":
			echo '<input type="checkbox" name="easygalleryslider[fs][pausePlay]" value="true"'.(($egsoptions[fs][pausePlay]==true)?' checked="checked"':"").' />'; break;
		case "fs_random":
			echo '<input type="checkbox" name="easygalleryslider[fs][randomize]" value="true"'.(($egsoptions[fs][randomize]==true)?' checked="checked"':"").' />'; break;
		case "fs_loop":
			echo '<input type="checkbox" name="easygalleryslider[fs][animationLoop]" value="true"'.(($egsoptions[fs][animationLoop]==true)?' checked="checked"':"").' /><div class="egs-opinfo">This applies to automatic sliding and manual. If manual, clicking next on the last slide will bring you to the first.'; break;
		case "fs_actionpause":
			echo '<input type="checkbox" name="easygalleryslider[fs][pauseOnAction]" value="true"'.(($egsoptions[fs][pauseOnAction]==true)?' checked="checked"':"").' />'; break;
		case "fs_hover":
			echo '<input type="checkbox" name="easygalleryslider[fs][pauseOnHover]" value="true"'.(($egsoptions[fs][pauseOnHover]==true)?' checked="checked"':"").' />'; break;
		case "width":
			echo '<input type="text" name="easygalleryslider[width]" size="3" value="'.$egsoptions[width].'" /> px<div class="egs-opinfo">This is the maximum width the slider will expand to if the page and any container it may be in allows.</div>'; break;
		case "height":
			echo '<input type="text" name="easygalleryslider[height]" size="3" value="'.$egsoptions[height].'" /> px<div class="egs-opinfo">This is the maximum height the slider will expand to if the page and any container it may be in allows.</div>'; break;
		case "enlarge":
			echo '<select name="easygalleryslider[enlarge]" id="egs-enlarge"><option value="1"'.(($egsoptions[enlarge]===1)?' selected="selected"':"").'>enlarge to fill</option><option value="2"'.(($egsoptions[enlarge]===2)?' selected="selected"':"").'>enlarge to fit</option><option value="3"'.(($egsoptions[enlarge]===3)?' selected="selected"':"").'>stretch to fill</option><option value="4"'.(($egsoptions[enlarge]===4)?' selected="selected"':"").'>don\'t enlarge</option></select><div class="egs-opinfo"><u>enlarge to fit</u>: The slider may shrink. Use a background color to avoid this.<br /><u>don\'t enlarge</u>: The slider may shrink.<p /><em>The max dimensions are used to determine small images.</em></div>'; break;
		case "enlarge_xy":
			echo '<select name="easygalleryslider[enlarge_xy]" id="egs-enlarge-xy"><option value="1"'.(($egsoptions[enlarge_xy]===1)?' selected="selected"':"").'>either</option><option value="2"'.(($egsoptions[enlarge_xy]===2)?' selected="selected"':"").'>both</option><option value="3"'.(($egsoptions[enlarge_xy]===3)?' selected="selected"':"").'>width</option><option value="4"'.(($egsoptions[enlarge_xy]===4)?' selected="selected"':"").'>height</option></select><div class="egs-opinfo"><em>If option selected here is smaller than max dimensions (defined above), the image is considered small.</em></div>'; break;
		case "matte":
			echo '<input type="text" id="egs-matte" name="easygalleryslider[matte]" size="5" value="'.$egsoptions[matte].'" /><div id="farb-colorpick" style="display:none;"></div><div class="egs-opinfo">HTML color. Using this makes small images appear on a background of the max height & length (specified above) and maintains the dimensions of the slider. Currently only available for "enlarge to fit".<br /><strong>Leave blank for no background.</strong></div>'; break;
		case "auto_insert":
			echo '<select name="easygalleryslider[auto_insert]"><option value="1"'.(($egsoptions[auto_insert]===1)?' selected="selected"':"").'>none</option><option value="2"'.(($egsoptions[auto_insert]===2)?' selected="selected"':"").'>posts</option><option value="3"'.(($egsoptions[auto_insert]===3)?' selected="selected"':"").'>pages</option><option value="4"'.(($egsoptions[auto_insert]===4)?' selected="selected"':"").'>pages & post</option></select>'; break;
		case "title":
			echo '<input type="checkbox" name="easygalleryslider[title]" value="true"'.(($egsoptions[title]==true)?' checked="checked"':"").' />'; break;
		case "shortcode":
			echo '<input type="checkbox" name="easygalleryslider[shortcode]" value="true"'.(($egsoptions[shortcode]==true)?' checked="checked"':"").' /><br /><div class="egs-opinfo">Scripts will load on every page.</div>'; break;
		case "exclude":
			echo '<input type="checkbox" name="easygalleryslider[exclude]" value="true"'.(($egsoptions[exclude]==true)?' checked="checked"':"").' /><div class="egs-opinfo">The menu order field is on the Gallery attachment tab of the individual posts.</div>'; break;
		case "num_slides":
			echo '<input type="text" name="easygalleryslider[num_slides]" size="3" value="'.$egsoptions[num_slides].'" /><br /><div class="egs-opinfo">Blank or 0 for unlimited.</div>'; break;
		case "order":
			echo '<select name="easygalleryslider[order]"><option value="1"'.(($egsoptions[order]===1)?' selected="selected"':"").'>menu order</option><option value="2"'.(($egsoptions[order]===2)?' selected="selected"':"").'>date (ascending)</option><option value="3"'.(($egsoptions[order]===3)?' selected="selected"':"").'>date (descending)</option></select>'; break;
		case "spinner":
			echo '<input type="checkbox" name="easygalleryslider[spinner]" value="true"'.(($egsoptions[spinner]==true)?' checked="checked"':"").' /><div class="egs-opinfo">The height of the spinner is 100px and the slider is 150px.</div>'; break;
	}
}

function easygalleryslider_options_validate($input) {
	$egs = get_option('easygalleryslider');
	$output[ver] = isset($egs[ver])? $egs[ver] : '';
	$output[fs][animation] = $input[fs][animation]==('fade'||'slide')? $input[fs][animation] : $egs[fs][animation];
	$output[fs][slideDirection] = $input[fs][slideDirection]==('horizontal'||'vertical')? $input[fs][slideDirection] : $egs[fs][slideDirection];
	$output[fs][slideshow] = $input[fs][slideshow]=='true'? true : false;
	$output[fs][slideshowSpeed] = is_numeric($input[fs][slideshowSpeed])? (int)$input[fs][slideshowSpeed] : $egs[fs][slideshowSpeed];
	$output[fs][animationDuration] = is_numeric($input[fs][animationDuration])? (int)$input[fs][animationDuration] : $egs[fs][animationDuration];
	$output[fs][directionNav] = $input[fs][directionNav]=='true'? true : false;
	$output[fs][controlNav] = $input[fs][controlNav]=='true'? true : false;
	$output[fs][keyboardNav] = $input[fs][keyboardNav]=='true'? true : false;
	$output[fs][mousewheel] = $input[fs][mousewheel]=='true'? true : false;
	$output[fs][pausePlay] = $input[fs][pausePlay]=='true'? true : false;
	$output[fs][randomize] = $input[fs][randomize]=='true'? true : false;
	$output[fs][animationLoop] = $input[fs][animationLoop]=='true'? true : false;
	$output[fs][pauseOnAction] = $input[fs][pauseOnAction]=='true'? true : false;
	$output[fs][pauseOnHover] = $input[fs][pauseOnHover]=='true'? true : false;
	$output[width] = is_numeric($input[width])? (int)$input[width] : $egs[width];
	$output[height] = is_numeric($input[height])? (int)$input[height] : $egs[height];
	$output[enlarge] = $input[enlarge]==(1||2||3||4)? (int)$input[enlarge] : $egs[enlarge];
	$output[enlarge_xy] = $input[enlarge_xy]==(1||2||3||4)? (int)$input[enlarge_xy] : $egs[enlarge_xy];
	$output[matte] = ((preg_match('/^#[a-f0-9]+$/i', $input[matte])&&strlen($input[matte])==7||strlen($input[matte])==4)||$input[matte]=='')? $input[matte] : $egs[matte];
	$output[auto_insert] = $input[auto_insert]==(1||2||3||4)? (int)$input[auto_insert] : $egs[auto_insert];
	$output[spinner] = $input[spinner]=='true'? true : false;
	$output[title] = $input[title]=='true'? true : false;
	$output[shortcode] = $input[shortcode]=='true'? true : false;
	$output[exclude] = $input[exclude]=='true'? true : false;
	if ($input[num_slides] == ('0'||'')) $output[num_slides] = 0;
	else $output[num_slides] = is_numeric($input[num_slides])? (int)$input[num_slides] : $egs[num_slides];
	$output[order] = $input[order]==(1||2||3)? (int)$input[order] : $egs[order];
	return $output;
}

add_action('admin_menu', 'easygalleryslider_admin_add_page');
function easygalleryslider_admin_add_page() {
	add_options_page('Easy Gallery Slider', 'Easy Gallery Slider', 'manage_options', 'easygalleryslider', 'easygalleryslider_options_page');
}

add_action('admin_print_scripts-settings_page_easygalleryslider', 'easygalleryslider_admin_enqueue');
function easygalleryslider_admin_enqueue() {
	wp_enqueue_script('jquery-ui-tabs');
	wp_enqueue_style('egs-admin-style',plugins_url('style.css', __FILE__));
	wp_enqueue_style( 'farbtastic' );
	wp_enqueue_script( 'farbtastic' );
}

function easygalleryslider_options_page() {
	?>
	<script type="text/javascript">jQuery(document).ready(function(){
			jQuery( "#egs-tabs" ).tabs({
				selected: -1,
				collapsible: true,
				fx: { height: 'toggle', opacity: 'toggle' }
			});
			jQuery('#egs-settings h3').click(function() {
				jQuery(this).next().toggle();
				return false;
			});
			jQuery('#egs-settings h3').not(':eq(0)').next().hide();
			jQuery('#egs-enlarge').change(function() {egs_field_hs(this,'#egs-matte',2);egs_field_hs(this,'#egs-enlarge-xy',-1);}).trigger('change');
			jQuery('#farb-colorpick').farbtastic('#egs-matte');
			jQuery("#egs-matte").click(function(){if(jQuery(this).val() == ""){jQuery(this).val('#ffffff');} 	jQuery('#farb-colorpick').fadeIn();});
			jQuery("#egs-matte").blur(function(){jQuery('#farb-colorpick').fadeOut();});
		});
		function egs_field_hs(sub,tar,cond) {
			var subval = sub.options[sub.selectedIndex].value;
			if ((cond < 0 && subval != -cond) || (subval == cond && cond > 0)) { jQuery(tar).parent('td').parent('tr').show(); }
			else { jQuery(tar).parent('td').parent('tr').hide(); }
		}
	</script>
	<div>
	<h2>Easy Gallery Slider</h2>
	<div id="egs-tabs">
	<ul id="egs-tab-top"><li><a href="#egs-help"><img src="<?php echo EGSLIDER_URL; ?>admin-page/helpbk.png" border=0 />Documentation</a></li><li><a href="#egs-contact"><img src="<?php echo EGSLIDER_URL; ?>admin-page/caution.png" border=0 /> Help</a></li><li><a href="#egs-donate"><img src="<?php echo EGSLIDER_URL; ?>admin-page/thumbup.png" border=0 /> Donate</a></li></ul><div style="clear:both;"></div>
	<div id="egs-help" class="egs-tabs">
		<p class="egs-heading">Selecting images</p>
		<div class="egs-body">When displayed on a singular page (a post or page) by default the images attached to that post or page are used. If there are attached images you'd like to be excluded, set the menu order to 999 and check the "Exclude images" option below.<p class="egs-sub">Directions on attaching images can be found <a href="http://codex.wordpress.org/Inserting_Images_into_Posts_and_Pages" target="_blank">here</a> (only steps 1-3 are necessary.)</p></div>
		<p class="egs-heading">Displaying the slider</p>
		<div class="egs-body"><p>You can display the slider in three ways.</p>
		<span class="egs-inhead">Automatically</span><div>The slider will be inserted between the title and content of every post, page or both.<p class="egs-sub">Set the "Automatically insert above" option below.</p></div>
		<p style="clear:both;height:5px;"></p>
		<span class="egs-inhead">Shortcode</span><div>Use the shortcode <b>[egslider]</b>
		<p class="egs-sub">Be sure to check "Enable shortcode/PHP function" below.</p></div>
		<p style="clear:both;height:5px;"></p>
		<span class="egs-inhead">PHP Function</span> <div>Insert the following code in a template file: <?php highlight_string("<?php egs_display(); ?>"); ?><br/>
		<p class="egs-sub">Be sure to check "Enable shortcode/PHP function" below.</p></div>
		</div>
	</div>
	<div id="egs-contact" class="egs-tabs">Have you encountered a problem you can't solve? Find a bug? Have a request for a new feature?
	<div><p class="egs-heading">Visit the website below and contact the author</p>
	<p class="egs-heading"><a href="http://inexi.com/wordpress" target="_blank">www.inexi.com</a></p>
	</div>
	</div>
	<div id="egs-donate" class="egs-tabs">
		<div><form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_s-xclick">
		<input type="hidden" name="hosted_button_id" value="E454JW67GKEKW">
		<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal">
		<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
		</form>
		Any donations are greatly appreciated! Your donations help encourage further development of this plugin. Thank you! :)</div>
	</div>
	</div>
	<div style="clear:both;"></div>
	<form action="options.php" method="post">
	<?php settings_fields('easygalleryslider_options'); ?>
	<div id="egs-settings">
	<?php do_settings_sections('easygalleryslider'); ?>
	</div>
	<p />
	<input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
	</form></div>
	
	<?php
}
?>
